#include "intlistmodel.h"

IntListModel::IntListModel(QObject *parent) :
  QAbstractListModel(parent)
{
  //Заполнение модели данными (для простоты прямо в конструкторе)
  items << 435 << 34 << 22 << 789;
}


int IntListModel::rowCount(const QModelIndex &parent) const
{
  //возвращаем кол-во элементов
  return items.count();
}

QVariant IntListModel::data(const QModelIndex &index, int role) const
{
  if (!index.isValid()){
    return QVariant();
  }
  //возвращаем значение элемента по индексу
  if (role == Qt::DisplayRole){
    return items.at(index.row());
  }
  else {
    return QVariant();
  }
}

void IntListModel::sort(int column, Qt::SortOrder order)
{
  //сигнал, предупреждающий о том, что компоновка элементов будет меняться
  emit layoutAboutToBeChanged();

  //сортировка элементов в контейнере элементов в зависимости от направления
  if (order == Qt::AscendingOrder){    
    std::sort(items.begin(), items.end(), std::less<int>());
  }
  else {
    std::sort(items.begin(), items.end(), std::greater<int>());
  }
  //сигнал, сообщающий о изменении компоновки элементов модели
  emit layoutChanged();
}
